unit UDrgDrp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Outline, DirOutln, UDragDrop, StdCtrls, FileCtrl, Menus;

type

  TfDragDrop = class(TForm)
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    ListBox1: TListBox;
    Label1: TLabel;
    ListBox2: TListBox;
    Label2: TLabel;
    OK: TButton;
    Button1: TButton;
    Button2: TButton;
    DragDrop1: TDragDrop;
    CheckBox1: TCheckBox;
    procedure FileListBox1DblClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure DragDrop1DragDrop(Sender: TObject; AbsolutePoint,
      RelativePoint: TPoint; var Effects: TDropEffects);
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DragDrop1DragEnter(Sender: TObject; AbsolutePoint,
      RelativePoint: TPoint; var Effects: TDropEffects);
    procedure DragDrop1DragLeave;
    procedure DragDrop1DragOver(Sender: TObject; AbsolutePoint,
      RelativePoint: TPoint; var Effects: TDropEffects);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fDragDrop: TfDragDrop;

implementation

uses UHelp;

{$R *.DFM}

procedure TfDragDrop.FileListBox1DblClick(Sender: TObject);
begin
  ListBox1.Items.Add(FileListBox1.FileName) ;
end;

procedure TfDragDrop.OKClick(Sender: TObject);
begin
  Close ;
end;

procedure TfDragDrop.Button1Click(Sender: TObject);
begin
  fHelp.ShowModal
end;

procedure TfDragDrop.Button2Click(Sender: TObject);
begin
  ListBox1.Clear ;
  ListBox2.Clear ;
end;

procedure TfDragDrop.DragDrop1DragDrop(Sender: TObject; AbsolutePoint,
  RelativePoint: TPoint; var Effects: TDropEffects);
begin
  ListBox2.Items.Assign(DragDrop1.DropFileList);
  Caption := Caption + ' (' + IntToStr(RelativePoint.X) + ',' + IntToStr(RelativePoint.Y) + ')' + ' (' + IntToStr(AbsolutePoint.X) + ',' + IntToStr(AbsolutePoint.Y) + ')';
end;

procedure TfDragDrop.ListBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  DragDrop1.DragFileList.Assign(ListBox1.Items);
  DragDrop1.DoDrag;
end;

procedure TfDragDrop.DragDrop1DragEnter(Sender: TObject; AbsolutePoint,
  RelativePoint: TPoint; var Effects: TDropEffects);
begin
  Beep;
end;

procedure TfDragDrop.DragDrop1DragLeave;
begin
  Caption := 'Bye bye Drag''n''Drop ...' ;
end;

procedure TfDragDrop.DragDrop1DragOver(Sender: TObject; AbsolutePoint,
  RelativePoint: TPoint; var Effects: TDropEffects);
begin
  Caption := TWinControl(Sender).Name;
  If not ( Sender is TListBox ) then Effects := [] ;
end;

procedure TfDragDrop.CheckBox1Click(Sender: TObject);
begin
  DragDrop1.DropActive := CheckBox1.Checked ;
end;

end.


